﻿//////////////////////////////////////////////
// FilmGrainProgramTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Utils/ProgramTracker.h"

#include "FilmGrainEffectInfo.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

/// Internals --------------------------------

namespace nkAstraeus
{
	struct FilmGrainProgramIdGenerator
	{
		static unsigned long long generate (const FilmGrainEffectInfo& info) ;
	} ;

	struct FilmGrainProgramNameGenerator
	{
		constexpr static const char* name = "NILKINS_FILM_GRAIN_PROGRAM_" ;
	} ;
}

/// Class ------------------------------------

namespace nkAstraeus
{
	class FilmGrainProgramTracker final : public ProgramTracker<FilmGrainEffectInfo, FilmGrainProgramIdGenerator, FilmGrainProgramNameGenerator>, public nkCommon::SingletonClass<FilmGrainProgramTracker>
	{
		friend class SingletonClass<FilmGrainProgramTracker> ;

		private :

			// Functions
			// Constructor, destructor
			FilmGrainProgramTracker () ;
			~FilmGrainProgramTracker () ;
	} ;
}