﻿//////////////////////////////////////////////
// EditBox.h
//
//////////////////////////////////////////////

/// Defines / Macro --------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"

#include "../Dll/DllDefines.h"

#include "../Inputs/CharEventData.h"

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT EditBox : public Component
	{
		protected :

			// Attributs
			// Si nous ne sommes que des chiffres ou pas
			bool _onlyNumbers ;
			// Le place holder
			std::string _placeHolder ;

			// Callback
			std::function<bool (EditBox*, const CharEventData&)> _charCallback ;
		
		public :
		
			// Constructeur, destructeur
			EditBox (MainSystem* parentSystem) ;
			~EditBox () ;

			// Getters
			std::function<bool (EditBox*, const CharEventData&)> getCharCallback () const ;

			// Setters
			virtual void setOnlyNumbers (bool value) ;
			virtual void setPlaceHolder (const nkMemory::StringView& text) ;
			virtual void setCaretPosition (unsigned int letterIndex) = 0 ;
			void setCharCallback (std::function<bool (EditBox*, const CharEventData&)> value) ;

			// Import / Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}